unit Dbtable;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, DbForm, Dialogs, DB, DBTables, DBCtrls, ExtCtrls, Grids, DBGrids;

type
  TTableViewForm = class(TDbForm)
    TableGrid: TDBGrid;
    TableDataSource: TDataSource;
    TableView: TTable;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    constructor Create (AOwner: TComponent; Db: TDatabase; const Name: string);
  end;

var
  TableViewForm: TTableViewForm;

implementation

{$R *.DFM}

uses DbMain;

constructor TTableViewForm.Create (AOwner: TComponent; Db: TDatabase;
                                   const Name: string);
begin
  inherited Create (AOwner);
  Database := Db;
  Caption := Format ('View - Database %s  Table %s', [Db.DatabaseName, Name]);
  TableView.DatabaseName := Db.DatabaseName;
  TableView.TableName := Name;
  TableView.Active := True;
  Show
end;

procedure TTableViewForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DbMainForm.FormCloseActive (Sender, Action)
end;

procedure TTableViewForm.FormActivate(Sender: TObject);
begin
  DbMainForm.SetActiveForm (TableDataSource, TableDataSource)
end;

end.
